/*
*  
*  $Id: iherramientareset.h 4330 2011-10-25 10:28:33Z tovar $
*  Ginkgo CADx Project
*
*  Copyright 2008-10 MetaEmotion S.L. All rights reserved.
*  http://ginkgo-cadx.com
*
*  This file is licensed under LGPL v3 license.
*  See License.txt for details
*
*/
#pragma once
#include <api/iherramienta.h>
#include "icontratoscore.h"
#include "iherramientascore.h"

namespace GNC {
	namespace GCS {
		class EXTAPI IHerramientaReset: public IHerramienta, public IContratable<IContratoWidgets> {
		public:
			typedef GNC::GCS::IContratoWidgets               TContratoWidgets;
			typedef GNC::GCS::IContratable<TContratoWidgets> TContratableWidgets;

			static const IHerramienta::UID ID = HCore_Reset;
			IHerramientaReset() : IHerramienta(HCore_Reset,TMenuImagen, _Std("Reset window level and zoom")) {};
			~IHerramientaReset() {};

			virtual void SetVistaActiva(GNC::GCS::IVista* pVista) = 0;

			virtual void ConectarContratos(bool) = 0;

			virtual bool ValidaContratos(GNC::GCS::IVista* pVista) {
				return IContratable<IContratoWidgets>::ValidaContrato(pVista);
			}

		};
	}
}
