/*
 *  
 *  $Id: selectfilesdicomdir.h 4403 2011-11-14 10:59:24Z tovar $
 *  Ginkgo CADx Project
 *
 *  Copyright 2008-10 MetaEmotion S.L. All rights reserved.
 *  http://ginkgo-cadx.com
 *
 *  This file is licensed under LGPL v3 license.
 *  See License.txt for details
 *
 *
 */
#pragma once
#include <api/iwizard.h>
#include <api/ivista.h>
#include <api/controllers/ipacscontroller.h>
#include "dicomdirexportbase.h"

#include <string>
#include <vector>

class IModeloDicom;

namespace GNC {

	namespace GUI {

		class SelectFilesDicomDir: public SelectFilesDicomDirBase, public IPasoWizard
		{
			public:
				typedef std::list<std::string> TListUIDs;
				SelectFilesDicomDir(wxWindow* pParent, const TListUIDs& uids , IWizard* pWizard);
				~SelectFilesDicomDir();

			protected:
			//region "Metodos heredados de IPasoWizard"
				virtual std::string GetTitle();

				virtual std::string GetSubTitle();

				virtual bool Siguiente();

				virtual bool Anterior();

				virtual bool Cancelar();

				virtual bool Validar();
			//endregion
		protected:
				wxArrayString m_ListaServidoresPACS;

		};
	}
}
